"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
function decodeObject(rawObject, transform) {
    var _this = this;
    return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
        var transformObject, result, _a, _b, _i, key, _c, _d, err_1;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (Array.isArray(rawObject)) {
                        return [2 /*return*/, reject(JSON.stringify(rawObject) + " should not be array")];
                    }
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 6, , 7]);
                    transformObject = transform(rawObject);
                    result = {};
                    _a = [];
                    for (_b in transformObject)
                        _a.push(_b);
                    _i = 0;
                    _e.label = 2;
                case 2:
                    if (!(_i < _a.length)) return [3 /*break*/, 5];
                    key = _a[_i];
                    if (!transformObject.hasOwnProperty(key)) return [3 /*break*/, 4];
                    _c = result;
                    _d = key;
                    return [4 /*yield*/, transformObject[key]];
                case 3:
                    _c[_d] = _e.sent();
                    _e.label = 4;
                case 4:
                    _i++;
                    return [3 /*break*/, 2];
                case 5:
                    resolve(result);
                    return [3 /*break*/, 7];
                case 6:
                    err_1 = _e.sent();
                    reject(JSON.stringify(rawObject) + " is not valid: " + err_1);
                    return [3 /*break*/, 7];
                case 7: return [2 /*return*/];
            }
        });
    }); });
}
exports.decodeObject = decodeObject;
function decodeBoolean(rawPrimitive) {
    return new Promise(function (resolve, reject) {
        if (typeof rawPrimitive !== 'boolean') {
            reject(JSON.stringify(rawPrimitive) + " should be boolean");
        }
        resolve(rawPrimitive);
    });
}
exports.decodeBoolean = decodeBoolean;
function decodeNumber(rawPrimitive) {
    return new Promise(function (resolve, reject) {
        if (typeof rawPrimitive !== 'number') {
            reject(JSON.stringify(rawPrimitive) + " should be number");
        }
        resolve(rawPrimitive);
    });
}
exports.decodeNumber = decodeNumber;
function decodeString(rawPrimitive) {
    return new Promise(function (resolve, reject) {
        if (typeof rawPrimitive !== 'string') {
            reject(JSON.stringify(rawPrimitive) + " should be string");
        }
        resolve(rawPrimitive);
    });
}
exports.decodeString = decodeString;
function decodeOptionalPrimitive(raw, transform) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (raw === undefined) {
                return [2 /*return*/, resolve(raw)];
            }
            transform(raw);
            return [2 /*return*/];
        });
    }); });
}
exports.decodeOptionalPrimitive = decodeOptionalPrimitive;
function decodeOptionalObject(raw, transform) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (raw === undefined) {
                return [2 /*return*/, resolve(raw)];
            }
            transform(raw);
            return [2 /*return*/];
        });
    }); });
}
exports.decodeOptionalObject = decodeOptionalObject;
